<!-- HTML header for doxygen 1.8.9.1
Converted manually by Andy Dent to be HTML 5 instead of XHTML
-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
        "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=9" />
<meta name="generator" content="Doxygen 1.8.12" />
<link rel="icon" href="https://realm.io/img/favicon.ico" />
<link rel="apple-touch-icon-precomposed" sizes="57x57" href="https://realm.io/img/favicon-57x57.png" />
<link rel="apple-touch-icon-precomposed" sizes="114x114" href="https://realm.io/img/favicon-114x114.png" />
<link rel="apple-touch-icon-precomposed" sizes="72x72" href="https://realm.io/img/favicon-72x72.png" />
<link rel="apple-touch-icon-precomposed" sizes="144x144" href="https://realm.io/img/favicon-144x144.png" />
<link rel="apple-touch-icon-precomposed" sizes="120x120" href="https://realm.io/img/favicon-120x120.png" />
<link rel="apple-touch-icon-precomposed" sizes="152x152" href="https://realm.io/img/favicon-152x152.png" />
<link rel="icon" type="image/png" href="https://realm.io/img/favicon-32x32.png" sizes="32x32" />
<link rel="icon" type="image/png" href="https://realm.io/img/favicon-16x16.png" sizes="16x16" />
<title>Realm Xamarin: LINQ support in Realm Xamarin</title>
<link href="tabs.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript">
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
  ga('create', 'UA-50247013-1', 'auto');
  ga('send', 'pageview');
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="realmcustomdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Realm Xamarin
   &#160;<span id="projectnumber">v0.81.0</span>
   </div>
   <div id="projectbrief">Realm for Xamarin</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">LINQ support in Realm Xamarin </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>To make a query with Realm, you use the <code>Realm.All&lt;T&gt;()</code> method to get a <code>IQueryable&lt;T&gt;</code> instance. On this you can then apply the operators listed below.</p>
<h2>Restriction Operators</h2>
<p><code>Where</code> is supported. <code>OfType</code> is not but it would be redundant as a query in Realm will always consist of a collection of the class initially specified.</p>
<p><code>Where</code> takes a predicate. To see the supported operations for predicates in Realm queries, refer to the <a href="#predicate-operations">Predicate Operations</a> section.</p>
<p>Example: </p><div class="fragment"><div class="line">var oldDogs = realm.All&lt;Dog&gt;().Where(dog =&gt; dog.Age &gt; 8);</div></div><!-- fragment --><h2>Ordering Operators</h2>
<p><code>OrderBy</code>, <code>OrderByDescending</code>, <code>ThenBy</code> and <code>ThenByDescending</code> are all supported. <code>Reverse</code> is not yet supported. Currently, you can only order by persisted properties on the class that you are querying. This means that <code>dogs.OrderBy(dog =&gt; dog.Owner.FirstName)</code> and the like is not yet supported.</p>
<p>Example: </p><div class="fragment"><div class="line">var contacts = realm.All&lt;Person&gt;().OrderBy(p =&gt; p.LastName).ThenBy(p =&gt; p.FirstName);</div></div><!-- fragment --><h2>Conversion Operators</h2>
<p><code>ToArray</code>, <code>ToList</code>, <code>ToDictionary</code> and <code>ToLookup</code> are all supported. <code>Cast</code> isn't, but it would be redundant as a query in Realm will always consist of a collection of the class initially specified.</p>
<p>Example: </p><div class="fragment"><div class="line">var phoneBook = realm.All&lt;Person&gt;().ToDictionary(person =&gt; person.PhoneNumber);</div></div><!-- fragment --><h2>Element Operators</h2>
<p>All of the main element operators are supported:</p>
<ul>
<li><code>First</code> and <code>FirstOrDefault</code></li>
<li><code>Last</code> and <code>LastOrDefault</code></li>
<li><code>Single</code> and <code>SingleOrDefault</code>.</li>
</ul>
<p>These methods take an optional predicate. To see the supported operations for predicates in Realm queries, refer to the <a href="#predicate-operations">Predicate Operations</a> section.</p>
<p>Access to a single element by an index is supported by <code>ElementAt</code> and <code>ElementAtOrDefault</code>.</p>
<p>Note that, as is standard C# behaviour of <code>default(T)</code>, the variants <code>...OrDefault</code> return a single null <code>RealmObject</code> if there is no matching element.</p>
<p><code>DefaultIfEmpty</code> is not yet supported.</p>
<h2>Quantifiers</h2>
<p><code>Any</code> is supported.</p>
<p><code>All</code> and <code>Contains</code> are not yet supported.</p>
<p><code>Any</code> takes an optional predicate. To see the supported operations for predicates in Realm queries, refer to the <a href="#predicate-operations">Predicate Operations</a> section.</p>
<h2>Aggregate Operators</h2>
<p><code>Count</code> is supported.</p>
<p><code>LongCount</code>, <code>Sum</code>, <code>Min</code>, <code>Max</code> and <code>Average</code> are not yet supported.</p>
<p><code>Count</code> takes an optional predicate. To see the supported operations for predicates in Realm queries, refer to the <a href="#predicate-operations">Predicate Operations</a> section.</p>
<p><a class="anchor" id="predicate-operations"></a>  </p><h2>Predicate Operations</h2>
<p>As a general rule, you can only create predicates with conditions that rely on data in Realm. Imagine a class </p><div class="fragment"><div class="line">class Person : RealmObject</div><div class="line">{</div><div class="line">    // Persisted properties</div><div class="line">    public string FirstName { get; set; }</div><div class="line">    public string LastName { get; set; }</div><div class="line"></div><div class="line">    // Non-persisted property</div><div class="line">    public string FullName { get { return FirstName + &quot; &quot; + LastName; } }</div><div class="line">}</div></div><!-- fragment --><p> Given this class, you can create queries with conditions that apply to the <code>FirstName</code> and <code>LastName</code> properties but not to the <code>FullName</code> property. Likewise, methods, public fields and properties with the <code>[Ignored]</code> attribute cannot be used.</p>
<p>Note that currently, the property must be the left side of a condition. This means that </p><div class="fragment"><div class="line">var oldDogs = realm.All&lt;Dog&gt;().Where(dog =&gt; 7 &lt; dog.Age); // INVALID query, do not copy</div></div><!-- fragment --><p> is illegal and would have to be changed into the equivalent </p><div class="fragment"><div class="line">var oldDogs = realm.All&lt;Dog&gt;().Where(dog =&gt; dog.Age &gt; 7); // Fixed</div></div><!-- fragment --><h2>Relational Operators</h2>
<p>Equality operators can be applied to all property types: <code>==</code>, <code>!=</code></p>
<p>Furthermore, the following can be used for numerical types: <code>&lt;</code>, <code>&lt;=</code>, <code>&gt;</code>, <code>&gt;=</code></p>
<h2>String Operators</h2>
<p>With strings, you can use: <code>Contains</code>, <code>StartsWith</code> and <code>EndsWith</code>. Currently, only case sensitive comparisons are supported.</p>
<p>Example: </p><div class="fragment"><div class="line">var peopleWhoseNameBeginsWithJ = realm.All&lt;Person&gt;.Where(person =&gt; person.FirstName.StartsWith(&quot;J&quot;));</div></div><!-- fragment --><h2>Composition</h2>
<p>You can use parentheses and the <code>||</code> and <code>&amp;&amp;</code> operators to compose queries.</p>
<p>Example: </p><div class="fragment"><div class="line">var PuppyRexes = realm.All&lt;Dog&gt;().Where(dog =&gt; dog.Age &lt; 2 &amp;&amp; dog.Name == &quot;Rex&quot;);</div></div><!-- fragment --><h2>A note on liveness</h2>
<p>Realm queries are <em>live</em>, in the sense that they will continue to represent the current state of the database.</p>
<div class="fragment"><div class="line">realm.Write(() =&gt; </div><div class="line">{</div><div class="line">    var p1 = realm.CreateObject&lt;Person&gt;();</div><div class="line">    p1.FirstName = &quot;John&quot;;</div><div class="line"></div><div class="line">    var p2 = realm.CreateObject&lt;Person&gt;();</div><div class="line">    p2.FirstName = &quot;Peter&quot;;</div><div class="line">});</div><div class="line"></div><div class="line">var js = realm.All&lt;Person&gt;().Where(p =&gt; p.FirstName.StartsWith(&quot;J&quot;));</div><div class="line"></div><div class="line">foreach(var j in js)</div><div class="line">    Console.WriteLine(j.FirstName); // ==&gt; John</div><div class="line"></div><div class="line">realm.Write(() =&gt;</div><div class="line">{</div><div class="line">    var p3 = realm.CreateObject&lt;Person&gt;();</div><div class="line">    p3.FirstName = &quot;Joe&quot;;</div><div class="line">});</div><div class="line"></div><div class="line">foreach(var j in js)</div><div class="line">    Console.WriteLine(j.FirstName); // ==&gt; John, Joe</div></div><!-- fragment --><p>This differs from the typical behavior of object/relational mappers (ORM's) where the result of a query is fetched and kept in memory as it was.</p>
<p>However, it also differs from the behavior of LINQ to Objects, where every iteration will reevaluate expressions, meaning that changes to both sides of a condition will affect the result. A Realm query will evaluate the right-hand sides of the conditions on the first run. So imagine you have a query like this:</p>
<div class="fragment"><div class="line">var recentLogEntries = realm.All&lt;LogEntry&gt;().Where(l =&gt; l.TimeStamp &gt; DateTime.Now.AddHours(-1));</div></div><!-- fragment --><p> Here, the <code>recentLogEntries</code> variable will contain all the log entries that have a <code>TimeStamp</code> later than one hour before the time when the query was first run (via <code>foreach</code>, <code>ToList</code> etc.) Newly added log entries will be included on subsequent runs, but the time they are compared to will not be updated.</p>
<h2>Not yet supported</h2>
<p>The following features are not yet supported. A few of them will not be supported as the Realm architecture renders them unnecessary.</p>
<h3>Grouping Operators</h3>
<p><code>GroupBy</code>is not supported.</p>
<h3>Set Operators</h3>
<p><code>Distinct</code>, <code>Union</code>, <code>Intersect</code> and <code>Except</code> are not supported.</p>
<h3>Partitioning Operators</h3>
<p><code>Take</code>, <code>Skip</code>, <code>TakeWhile</code> and <code>SkipWhile</code> are not yet supported.</p>
<p>These are less important than when using an ORM. Given Realm's zero-copy pattern, data is only read from the database when the properties on the objects are accessed, so there is little overhead in simply iterating over a part of a result.</p>
<h3>Projection Operators</h3>
<p><code>Select</code> and <code>SelectMany</code> are not yet supported.</p>
<p>The <code>select</code> keyword used with the query syntax is supported as long as you select the <code>RealmObject</code> itself and not some derivative: </p><div class="fragment"><div class="line">var oldDogs = from d in realm.All&lt;Dog&gt;() where d.Age &gt; 8 select d;</div></div><!-- fragment --><h2>Concatenation Operators</h2>
<p><code>Concat</code> is not supported.</p>
<h3>Join Operators</h3>
<p><code>Join</code> and <code>GroupJoin</code> are not supported.</p>
<p>Note that joins are less vital when using Realm than when using a relational database and an ORM. Instead of using keys to identify relations, you simply refer to the related object.</p>
<p>So given a class </p><div class="fragment"><div class="line">public class Address : RealmObject</div><div class="line">{</div><div class="line">    public string StreetName { get; set; }</div><div class="line">    public int Number { get; set; }</div><div class="line">}</div></div><!-- fragment --><p> you can simply use that in another class like so: </p><div class="fragment"><div class="line">public class Customer : RealmObject</div><div class="line">{</div><div class="line">    public string Name { get; set; }</div><div class="line">    public Address Address { get; set; }</div><div class="line">}</div></div><!-- fragment --><p> This works like an ordinary reference in C# which means that if two <code>Customer</code> instances are assigned the same <code>Address</code> object, changes to that address will apply to both customer objects. </p>
</div></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.9.1-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>© 2015 Realm. All rights reserved.<br />
Generated on Wed Dec 14 2016 14:42:34 for Realm Xamarin by &#160;<a href="http://www.doxygen.org/index.html">
doxygen
</a> 1.8.12
</small></address>
</body>
</html>
